    Device = 16F886   ; ̳
; 20E4
@CONFIG_REQ
    @__CONFIG _CONFIG1, 20E4h
    @__CONFIG _CONFIG2, 3fffh
;	@__CONFIG _CONFIG1, HS_OSC & WDT_OFF & MCLRE_ON & PWRTE_ON & CP_OFF & CPD_OFF & BOR_OFF & IESO_OFF & FCMEN_OFF & LVP_OFF &  DEBUG_OFF
;	@__CONFIG _CONFIG2, IESO_OFF & FCMEN_OFF
    Xtal = 4   ;   4 
    
    
    setttemp EData  250,0,300,350   ;   ( )
    setKp  EData  40                ;  .
    setKi  EData  0.3               ; 
    setNormkof EData 1              ;  
    
    Declare Bootloader = On         ;  
    Declare Adin_Res 10             ; 10-bit result required 
    Declare Adin_Tad FRC            ; RC OSC chosen 
    Declare Adin_Stime 100          ; Allow 50us sample time
    
    Declare  CCP1_Pin = PORTC.2     ;  
    
    Declare  Hserial_Baud  4800          '  , 
    Declare  Hserial_TXSTA = %00100000   '  ,  
    Declare  Hserial_RCSTA = %10010000   '  
    Declare  Hserial_SPBRG  12           '   SPBRG   
    Declare  Hserial_Clear = On          '    
    
    ;==========  Var  =================
    Dim delayd     As Byte               ;   --
    Dim delaydisp1 As Byte               ;   
    Dim DelayACP   As Byte               ;   --
    Dim delayacp1  As Byte               ;    
    Dim dlds       As Byte               ;  \  
    Dim delayds1   As Byte               ;    ( )
    
    Dim Cifra4     As Byte            ;   
    Dim Cifra3     As Byte            ; ************
    Dim Cifra2     As Byte            ; ************
    Dim Cifra1     As Byte            ; ************
    Dim Selector   As Byte            ;    
    Dim Address    As Byte            ;    '
    Dim OUTA       As Byte            ; ,    
    
    ;=====For PID ======
    Dim Ki As Float                   ;  
    Dim TempPower As Float            ;   
    Dim Koef_Duty As 0.333            ; . 
    Dim P As Float                    ;  
    Dim PI As Float                   ; 
    Dim Power As Word                 ;  
    Dim TError0 As Word               ;
    Dim TError1 As Word               ;
    Dim Integral As Word              ;
    Dim duty_1 As Byte                ;   
    Dim NormKof As Byte               ;  
    Dim Kp As Byte                    ;  .
    
    Dim TempSet As Word               ;  
    Dim Prs1    As Word               ;  1
    Dim Prs2    As Word               ;  2
    Dim Prs3    As Word               ;  3
    
    
    Dim Dig_Pat    As Byte            '    B
    Dim Flag1      As Bit             '    (0_, 1_)
    Dim Flag2      As Byte            '  
    Dim Flag3      As Byte
    Dim cifra      As Byte            '   
    Dim DigitDisp  As Byte            '  lookupl
    
    
    Dim SerString[3] As Byte          '  3   RS232
    
    Dim TDisplay   As Word            ;  
    Dim prostotak As Byte             ;     
    
    Dim i As Word                     ;
    Dim j As Word                     ;
    
    Dim AD_Result  As Word             ;  
    Dim TMP        As Byte             ; RS232

;Dim n As Byte
;Dim k As Word

    Symbol T0IE     = INTCON.5       ;   
;=====   ========
    Symbol ENT      = PORTB.0        ; SET
    Symbol one      = PORTB.1        ; 1
    Symbol two      = PORTB.2        ; 2
    Symbol thre     = PORTB.3        ; 3
    Dim    BUF As Byte               ;  BUTTON
    
    Symbol ledg = PORTB.4            ; 
    Symbol ledr = PORTB.5            ; 
 
     Asm
    mvi     Macro   DEST2,CONST2       
        movlw   CONST2
        movwf   DEST2
        Endm    
    EndAsm
    Declare FSR_CONTEXT_SAVE = On
    On_Hardware_Interrupt MyInt     ;     MyInt ( )


GoTo init                          ;     -->

;****************************************************************
;======================    ===========================
;****************************************************************

MyInt:
    DelayUS 1

    Asm
      incf dlds,f
      incf delayd,f
      incf DelayACP,f
      
      		movlw	B'00100000'		;      5
    		andwf	OUTA,F			;  ,    (PORTA)
    
    
       		movf	OUTA,W			; 
    		movwf	PORTA			; 
    		movf	Selector,W		; ϳ 
    		iorwf	OUTA,F			;  
    		
    		movf	Address,W		;    
    		movwf	FSR			    ;  FSR ( )
    		movf	INDF,W			;    W
            movwf   SSPBUF          ;    SPI
            
            
          	movf	OUTA,W			;  
    		movwf	PORTA			;  
    
    		bcf	STATUS,C
    		rrf	Selector,F
    
    		btfss	STATUS,C		;      ,   (1)
    		GoTo	Int_label		;    
    		
    		
            movlw	Cifra4			;  
    		movwf	Address			;  ADDRESS 
    		movlw	B'00001000'		;    
    		movwf	Selector		;  
    		GoTo	End_int			;
    
    Int_label	
            incf  Address,F         ;  ,   ( ADDRESS)
    		nop
    		nop
    		GoTo      End_int       ;
    End_Int                         
            bcf	INTCON,T0IF		    ; 
    EndAsm
      Context Restore
    
    ;Resume
    ;Enable
    
;==================   ======================
init: 
    Clear
    SSPSTAT = %00000000         ;  SPI
    SSPSTAT = %01000000         ; //
    SSPCON  = $21               ; //
    ;OSCCON = %01110000         ;   8 
    CM1CON0 = %00000000         ; 
    CM2CON0 = %00000000         ; 
    ANSEL = %00100000           ; 4  
    ANSELH = %00000000          ;    
    PORTA = 0                   ;
    TRISA = %00100000           ; RA5 ,  
    PORTB = 0                   ;
    TRISB = %00001111           ; RA0,RA1,RA2,RA3 - 
    ADCON1 = %10000000          ;   
    OPTION_REG = %00000010      ; TMR0 --- 1:8
    INTCON 	= %10100000         ;  
    TMR0 = 0                    ;
    PORTC = 0                   ;
    TRISC = %00000000           ; PORTC  
    
    
    Asm
       mvi    Address,Cifra4    ;  ADDRESS     
    EndAsm        
     Selector = %00001000       ;   4- 
    
     DelayACP = 0               ;  
     dlds  = 0                  ;   0
     delayds1 = 0               ;  **
     delayd = 0                 ;  **
     delaydisp1 = 0             ;  **
    
     j = 0
     Flag1 = 0                  ;   
     Flag2 = 0                  ;
     Flag3 = 0                  ; 
    ;====      ====
    
    Prs1.LowByte = ERead 0      ;  
    Prs1.HighByte = ERead 1     ;   
    Prs2.LowByte = ERead 2      ;  
    Prs2.HighByte = ERead 3     ; 
    Prs3.LowByte = ERead 4      ; ****
    Prs3.HighByte = ERead 5     ; ****
    
    
    Kp = ERead setKp            ;  
    Ki = ERead setKi            ; ʳ
    NormKof = ERead setNormkof  ; . .
    
    ;=========================================================
    ;=======   USART,  
    ;=========================================================
      Button ENT,0,40,5,BUF,0,initgo         ;      SET
      DelayMS 200                            ;   
      Cifra4 =  240                          ; 
      Cifra3 =  246                          ; 
      Cifra2 =  246                          ; 
      Cifra1 =  198                          ; 

      GoTo USART_                            ; 
initgo:
    ;============   
      Cifra4 =  249                          ; .
      Cifra3 =  191                          ; Pr-1
      Cifra2 =  175                          ; 
      Cifra1 =  140                          ; 
      TempSet = Prs1                         ;   1
      DelayMS 1000                           ;
      TDisplay = TempSet                     ;  
      GoSub Display                          ;      .1
      DelayMS 1000                           ;
    
    
        
;************************************************************    
;=====================     ===================
;************************************************************

main:
  If DelayACP >= 150 Then                     ;   DelayACP  150
   Inc delayacp1                              ;  delayacp1
   DelayACP = 0                               ;
    If delayacp1 >= 1 Then                    ;
        delayacp1 = 0                         ;
        AD_Result = ADIn 4                    ;     (RA5)
        DelayUS 1
;        HSerOut [Dec AD_Result,"    ", Dec j, 13, 0]
;        Inc j
;======================================================================================      
      If AD_Result > TempSet + 5 Then    ;     
           ledr = 1
           ledg = 1
      Else     
       If AD_Result < TempSet - 5 Then   ;    
          ledg = 0                       ;   
          ledr = 1                       ;
       Else                              ;
          ledg = 1                       ;  
          ledr = 0                       ; 
       EndIf      
      EndIf 
;=======================================================================================       
       If Flag1 = 0 Then                 ; ³
        TDisplay = AD_Result             ;  , 
       Else
        TDisplay = TempSet               ; 
       EndIf
        
        GoSub PID                        ;  PID 
        If AD_Result > TempSet + 15 Then ;   >   15. 
         HPWM 1, 1, 500                  ;     
        Else 
         HPWM 1, duty_1, 500             ; CCP1
        EndIf
    EndIf
  EndIf

;=======       =======
  If Flag3 = 1 Then                      ;
    If dlds >= 254 Then                  ;
     dlds = 0                            ;   
     Inc delayds1                        ;   
    EndIf                                ;   
      If delayds1 = 4 Then               ;    
        delayds1 = 0                     ;   
        Flag1 = 0                        ;   
        Flag3 = 0                        ;
      EndIf                              ;
  EndIf                                  ;
              
;============  SET ====================



  Button ENT,0,40,5,BUF,0,ButOne         ;   "SET"
    DelayMS 200                          ;   
    GoSub SelPrs                         ;  
    GoTo main                            ;

ButOne:                                  ;  1
  Button one,0,40,5,BUF,0,press2         ;
    DelayMS 200                          ;  
    TempSet = TempSet + 5                ; 
     dlds  = 0                           ;  
     delayds1 = 0                        ; 
     Flag1 = 1                           ;
     Flag3 = 1                           ;
    TDisplay = TempSet                   ;
    GoSub Display                        ;
    GoTo main                            ;
     
;========    2
press2:  
  Button two,0,40,5,BUF,0,press3         ;   2
    DelayMS 200                          ;
    TempSet = TempSet - 5                ;  
     dlds  = 0                           ;
     delayds1 = 0                        ;     1
     Flag1 = 1                           ;
     Flag3 = 1                           ;
    TDisplay = TempSet                   ;
    GoSub Display                        ;
    GoTo main                            ;
    
press3:  
   Button thre,0,40,5,BUF,0,Dsp          ; . 3
    DelayMS 200                          ;
    If Flag1 = 0 Then                    ;   
     Flag1 = 1                           ; 
    Else                                 ; 
     Flag1 = 0                           ; 
    EndIf                                ;
    GoTo main                            ;

Dsp:  
 If delayd >= 250 Then                   ;
      Inc delaydisp1                     ;  
      delayd = 0                         ;  
       If delaydisp1 = 1 Then            ;    
         GoSub Display                   ;    500
         delaydisp1 = 0                  ;
       EndIf
 EndIf
 
GoTo main
;===================================================
;    
;===================================================
Display:
    If Flag1 = 0 Then
      DigitDisp = 10
      GoSub LOOK
      Cifra4 =  cifra
    Else
      Cifra4 =  148
    EndIf
      DigitDisp = TDisplay Dig 0   
      GoSub LOOK
      Cifra3 = cifra
  
  DigitDisp = TDisplay Dig 1   
  GoSub LOOK
  Cifra2 = cifra

  DigitDisp = TDisplay Dig 2   
  GoSub LOOK
  Cifra1 = cifra


Return  




;============== PID =========================

PID:
        If TempSet > AD_Result Then                                    ;   > 
            TError0 = TempSet - AD_Result                              ;  = . - 
        Else                                                           ;  
            TError0 = 0                                                ;  = 0
        EndIf                                                          ;
        If 255 > Power And Power > 0 Then Integral = TError0 + TError1 ;       
        P = Kp * (TError0 + NormKof)                                   ;   
        PI = Ki * Integral                                             ;   
        TempPower = P + PI                                             ; 
        If TempPower > 765 Then Power = 255                            ;
        If TempPower < 0 Then Power = 0                                ;
        If 765 > TempPower And TempPower >= 0 Then                     ;
            TempPower = TempPower * Koef_Duty                          ;
            Power = TempPower;  //                ;
        EndIf                                                          ;
        duty_1 = Power                                                 ;
        TError1 = TError0                                              ;
Return

    
LOOK:

  ;                           0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 ,  
  cifra = LookUpL DigitDisp,[192,249,164,176,153,146,130,248,128,144,156]         
Return

;=====================  -   ====================
SelPrs:
     Cifra4 =  255  '
     Cifra3 =  146  ' S
     Cifra2 =  175  ' r
     Cifra1 =  140  ' P
     
  Button ENT,0,40,5,BUF,0,SelPrsB1         ' . ENT
    DelayMS 200
    GoSub SelSet
    Return   

SelPrsB1:
  Button one,0,40,5,BUF,0,SelPrsB2         
    DelayMS 200
     
     Cifra4 =  249
     Cifra3 =  191
     Cifra2 =  175
     Cifra1 =  140
     TempSet = Prs1
     DelayMS 1000
     TDisplay = TempSet
     GoSub Display
     DelayMS 1000
     Return
      
SelPrsB2:  
  Button two,0,40,5,BUF,0,SelPrsB3         
    DelayMS 200
     
     Cifra4 =  164
     Cifra3 =  191
     Cifra2 =  175
     Cifra1 =  140
     TempSet = Prs2
     DelayMS 1000

     TDisplay = TempSet
     GoSub Display
     DelayMS 1000
     Return

SelPrsB3:
  Button thre,0,40,5,BUF,0,SelPrs         
    DelayMS 200
     
     Cifra4 =  176
     Cifra3 =  191
     Cifra2 =  175
     Cifra1 =  140
     TempSet = Prs3
     DelayMS 1000

     TDisplay = TempSet
     GoSub Display
     DelayMS 1000
     Return     

;=====================  -  ====================
SelSet:
     Cifra4 =  255  '
     Cifra3 =  135  ' t
     Cifra2 =  134  ' E
     Cifra1 =  146  ' S
DelayMS 500     
SelSet1:
 If Flag2 = 0 Then
     DigitDisp =  Prs1 Dig 0
     GoSub LOOK
     Cifra4 =  cifra
     DigitDisp =  Prs1 Dig 1
     GoSub LOOK
     Cifra3 =  cifra
     DigitDisp =  Prs1 Dig 2
     GoSub LOOK
     Cifra2 =  cifra
     Cifra1 =  121
 Else If Flag2 = 1 Then
     DigitDisp =  Prs2 Dig 0
     GoSub LOOK
     Cifra4 =  cifra
     DigitDisp =  Prs2 Dig 1
     GoSub LOOK
     Cifra3 =  cifra
     DigitDisp =  Prs2 Dig 2
     GoSub LOOK
     Cifra2 =  cifra
     Cifra1 =  36
  Else   
     DigitDisp =  Prs3 Dig 0
     GoSub LOOK
     Cifra4 =  cifra
     DigitDisp =  Prs3 Dig 1
     GoSub LOOK
     Cifra3 =  cifra
     DigitDisp =  Prs3 Dig 2
     GoSub LOOK
     Cifra2 =  cifra
     Cifra1 =  48
   EndIf
 
  Button ENT,0,40,5,BUF,0,SelSetB1         ' . ENT
    DelayMS 200
     Select Flag2
           T0IE = 0 '    TMR0
      Case 0
        EWrite 0, [Prs1.LowByte]
        EWrite 1, [Prs1.HighByte]
      Case 1
        EWrite 2, [Prs2.LowByte]
        EWrite 3, [Prs2.HighByte]
      Case 2
        EWrite 4, [Prs3.LowByte]
        EWrite 5, [Prs3.HighByte]
     EndSelect
           T0IE = 1 '    TMR0
    Return   

SelSetB1:
  Button one,0,40,5,BUF,0,SelSetB2         
    DelayMS 200
     Select Flag2
      Case 0
        Inc Prs1
      Case 1
        Inc Prs2
      Case 2
        Inc Prs3     
     EndSelect
      GoTo SelSet1
      
SelSetB2:  
  Button two,0,40,5,BUF,0,SelSetB3         
    DelayMS 200
     Select Flag2
      Case 0
        Dec Prs1
      Case 1
        Dec Prs2
      Case 2
        Dec Prs3     
     EndSelect
      GoTo SelSet1


SelSetB3:
  Button thre,0,40,5,BUF,0,SelSet1         
    DelayMS 200
     Inc Flag2
      If Flag2 = 3 Then Flag2 = 0
       GoTo SelSet1


;============================================================
;  ********         *******
;============================================================
USART_:

loop1:
      Cifra4 =  240                          ; 
      Cifra3 =  246                          ; 
      Cifra2 =  246                          ; 
      Cifra1 =  198                          ; 
 
 HSerIn 100, loop1,[Str SerString]        ' 


 If SerString[0] = "q" And SerString[1] = "i"  Then
  DelayMS 10
  HSerOut ["OK_qi"]
'  DelayMS 200

  GoTo WriteK
 EndIf  

 If SerString[0] = "q" And SerString[1] = "r"  Then
  DelayMS 10
      Cifra4 =  255                          ; 
      Cifra3 =  255                          ; 
      Cifra2 =  175                          ; 
      Cifra1 =  152                          ; 

  HSerOut ["OK_qr"]

t1:  
     HSerIn 100, t1,[Str SerString]        ' 

 If SerString[0] = "k" And SerString[1] = "i"  Then
  DelayMS 30
  HSerOut ["OK_ki"]
  DelayMS 50
  HSerOut [Dec Ki]
;   DelayMS 10
 EndIf
t2:  
     HSerIn 100, t2,[Str SerString]        ' 

 If SerString[0] = "k" And SerString[1] = "p"  Then
  DelayMS 30
   HSerOut ["OK_kp"]
   DelayMS 50
   HSerOut [Dec Kp]
;   DelayMS 10
 EndIf
t3:  
     HSerIn 100, t3,[Str SerString]        ' 

 If SerString[0] = "k" And SerString[1] = "f"  Then
  DelayMS 30
   HSerOut ["OK_kf"]
  DelayMS 50
   HSerOut [Dec NormKof]
;   DelayMS 10
 EndIf
 


   SerString[0] = "n"

EndIf
GoTo loop1        


;================    =========================================

WriteK:
      Cifra4 =  135                          ; 
      Cifra3 =  239                          ; 
      Cifra2 =  175                          ; 
      Cifra1 =  193                          ; 

  HSerIn 100, WriteK,[Str SerString]        '      

  If SerString[0] = "k" And SerString[1] = "p"  Then  ;  "kp"
 ; TMP1 = 0
  DelayMS 20
  HSerOut ["OK_kp"]
  DelayMS 20

'   While TMP1 = 0
;t0ie = 0
timeout:  
     HSerIn 1000, timeout ,[Dec Ki.Byte0]
           DelayMS 300
;           HSerOut [Dec TMP2]
           HSerOut ["OK_b0"]

timeout1:  
     HSerIn 500, timeout1,[Dec Ki.Byte1]
           DelayMS 50
           HSerOut ["OK_b1"]
timeout2:  
     HSerIn 500, timeout2,[Dec Ki.Byte2]
           DelayMS 50
           HSerOut ["OK_b2"]
timeout3:  
     HSerIn 500, timeout3,[Dec Ki.Byte3]
     

             DelayMS 50
             HSerOut ["OK_b3"]
             ;Ki = TMP1
             DelayMS 350
             HSerOut [Dec Ki]


timeout4:  
     HSerIn 500, timeout4,[Dec TMP]
     Kp = TMP
               DelayMS 50
     HSerOut [Dec TMP]

timeout5:  
     HSerIn 500, timeout4,[Dec TMP]
     NormKof = TMP
     DelayMS 50
     HSerOut [Dec TMP]
     
T0IE = 0

  EWrite setKi,[Ki]
  EWrite setKp,[Kp]
  EWrite setNormkof,[NormKof]
       

T0IE = 1
  Else
    GoTo WriteK

  EndIf
     GoTo loop1  

End


